#!/usr/bin/perl -w

use strict;
use Math::BigInt lib => "GMP";

$#ARGV == 1 or die "usage: perl_mannwhitney_MBI_i.pl <size of both samples> <U>";

my ($size, $Ugiven)= @ARGV;

sub choose
{
  my ($n, $k)= @_;

  return 1 if $k == 0;
  return 0 if $n == 0;
  return choose($n-1, $k-1) * $n / $k;
}

sub nlimitchoices_l_b
{
  my ($n, $m, $u)= @_;
  my $sum= Math::BigInt->bzero();
  my @dstack;

  return Math::BigInt->bzero() if $u < 0;
  return Math::BigInt->bone() if $m == 0;
  push @dstack, 0;
  while( @dstack ) {
    while( $m > 1 ) {	# descend
      push @dstack, 0;
      --$n;
      --$m;
    }
    $sum->binc();
    while( @dstack ) {	# backtrack
      ++$dstack[-1];
      --$n;
      $u -= $m;
      last if $n >= $m && $u >= 0;
      $n += $dstack[-1]+1;
      $u += $m*$dstack[-1];
      ++$m;
      pop @dstack;
    }
  }
  return $sum;
}

print choose(2*$size, $size), "\n";

my $Usmaller= nlimitchoices_l_b(2*$size, $size, $Ugiven);

print $Usmaller->bstr(), "\n";


