#!/usr/bin/ruby

# require "memoize";
# include Memoize;

def choose(n, k)
  if k == 0
    return 1
  end
  if n <= 0
    return 0
  end
  return choose(n-1, k-1) * n / k
end

def nlimitchoices(n, m, u)
  if u < 0
    return 0
  end
  if m == 0
    return 1
  end
  total = 0
  (0 .. n-m).each do |d|
    total += nlimitchoices(n-d-1, m-1, u-m*d)
  end
  return total
end  

# memoize :nlimitchoices;

def nlimitchoices_i(n, m, u)
  if u < 0 || m < 0
    return 0
  end
  total = 0
  dstack= [ 0 ]
  while ! dstack.empty?
    # descend to first branch
    while m > 1
      dstack.push 0
      n -= 1
      m -= 1
    end
    # count this choice
    total += 1
    # backtrack and choose different branch
    while ! dstack.empty?
      dstack[-1] += 1
      n -= 1
      u -= m
      if n >= m && u >= 0	# choose this branch
	break
      end
      # backtrack
      n += dstack[-1] + 1
      u += m * dstack[-1]
      m += 1
      dstack.pop
    end
  end
  return total
end  

m= ARGV[0].to_i
u= ARGV[1].to_i
n= 2*m

puts choose(n, m)
puts nlimitchoices(n, m, u)


